﻿namespace U2UC.WinUni.MarchingAnts
{
    using System;
    using Windows.Foundation;
    using Windows.UI;
    using Windows.UI.Xaml;
    using Windows.UI.Xaml.Controls;
    using Windows.UI.Xaml.Media;
    using Windows.UI.Xaml.Shapes;

    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
            this.Loaded += MainPage_Loaded;
        }

        private void MainPage_Loaded(object sender, RoutedEventArgs e)
        {
            var maxY = this.TheMap.ActualHeight;
            var maxX = this.TheMap.ActualWidth;

            Polyline line = new Polyline();

            line.Points.Add(new Point(0, maxY));
            line.Points.Add(new Point(maxX * .1, maxY * .7));
            line.Points.Add(new Point(maxX * .3, maxY * .6));
            line.Points.Add(new Point(maxX * .4, maxY * .8));
            line.Points.Add(new Point(maxX * .6, maxY * .8));
            line.Points.Add(new Point(maxX * .8, maxY * .4));
            line.Points.Add(new Point(maxX * .7, maxY * .2));
            line.Points.Add(new Point(maxX, 0));

            line.Stroke = new SolidColorBrush(Colors.OrangeRed);
            line.StrokeThickness = 18;
            line.StrokeDashArray = new DoubleCollection() { 4, 2 };
            line.StrokeDashCap = PenLineCap.Round;
            line.StrokeLineJoin = PenLineJoin.Round;

            line.ApplyMarchingAntsAnimation(TimeSpan.FromSeconds(1));

            this.TheMap.Children.Add(line);

            Ellipse ellipse = new Ellipse();
            ellipse.Height = maxY * .3;
            ellipse.Width = maxX * .3;
            ellipse.Stroke = new SolidColorBrush(Colors.Yellow);
            ellipse.StrokeThickness = 12;
            ellipse.StrokeDashArray = new DoubleCollection() { 8, 4 };
            ellipse.StrokeDashCap = PenLineCap.Round;
            ellipse.ApplyMarchingAntsAnimation(TimeSpan.FromSeconds(1));

            this.TheMap.Children.Add(ellipse);
        }
    }
}
