﻿namespace U2UC.WinUni.MarchingAnts
{
    using System;
    using System.Linq;
    using Windows.UI.Xaml;
    using Windows.UI.Xaml.Media.Animation;
    using Windows.UI.Xaml.Shapes;

    /// <summary>
    /// Extension methods for the Shape class.
    /// </summary>
    public static class ShapeExtensions
    {
        public static void ApplyMarchingAntsAnimation(this Shape shape, TimeSpan duration)
        {
            Storyboard storyboard = new Storyboard();
            DoubleAnimation doubleAnimation = new DoubleAnimation();
            doubleAnimation.From = 0.0;
            doubleAnimation.To = -shape.StrokeDashArray.Sum();
            doubleAnimation.Duration = new Duration(duration);
            doubleAnimation.AutoReverse = false;
            doubleAnimation.RepeatBehavior = RepeatBehavior.Forever;
            doubleAnimation.EnableDependentAnimation = true; // Don't forget
            storyboard.Children.Add(doubleAnimation);
            Storyboard.SetTarget(doubleAnimation, shape);
            Storyboard.SetTargetProperty(doubleAnimation, "StrokeDashOffset");
            storyboard.Begin();
        }
    }
}
